// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/telemetry_content
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/references -i References -t ../../../assets/templates/middleware/telemetry_content -o telemetry_middleware.go -l ""

import (
	"context"
	"time"

	pkgId "git.perx.ru/perxis/perxis-go/id"
	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/items"
	"git.perx.ru/perxis/perxis-go/pkg/references"
	"git.perx.ru/perxis/perxis-go/pkg/telemetry/metrics"
	"go.opentelemetry.io/otel"
	"go.opentelemetry.io/otel/attribute"
	otelmetric "go.opentelemetry.io/otel/metric"
	"go.opentelemetry.io/otel/trace"
)

type spaceGetter interface {
	GetSpaceID() string
}

// telemetryMiddleware implements references.References interface instrumented with opentracing spans
type telemetryMiddleware struct {
	references.References
	_instance      string
	requestMetrics *metrics.RequestMetrics
	_spanDecorator func(span trace.Span, params, results map[string]interface{})
}

// TelemetryMiddleware returns telemetryMiddleware
func TelemetryMiddleware(base references.References, instance string, spanDecorator ...func(span trace.Span, params, results map[string]interface{})) telemetryMiddleware {
	requestMetrics, err := metrics.GetRequestMetrics()
	if err != nil {
		panic(err)
	}

	d := telemetryMiddleware{
		References:     base,
		_instance:      instance,
		requestMetrics: requestMetrics,
	}

	if len(spanDecorator) > 0 && spanDecorator[0] != nil {
		d._spanDecorator = spanDecorator[0]
	}

	return d
}

// Get implements references.References
func (_d telemetryMiddleware) Get(ctx context.Context, spaceId string, envId string, references []*references.Reference, options ...*references.GetOptions) (items []*items.Item, notfound []*references.Reference, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "References"),
		attribute.String("method", "Get"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "References.Get")
	defer _span.End()

	items, notfound, err = _d.References.Get(ctx, spaceId, envId, references, options...)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	spID = spaceId
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":        ctx,
			"spaceId":    spaceId,
			"envId":      envId,
			"references": references,
			"options":    options}, map[string]interface{}{
			"items":    items,
			"notfound": notfound,
			"err":      err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return items, notfound, err
}

// Publish implements references.References
func (_d telemetryMiddleware) Publish(ctx context.Context, spaceId string, envId string, references []*references.Reference, recursive bool, force bool) (published []*references.Reference, notfound []*references.Reference, unpublished []*references.Reference, err error) {
	var att = []attribute.KeyValue{
		attribute.String("service", "References"),
		attribute.String("method", "Publish"),
	}
	attributes := otelmetric.WithAttributeSet(attribute.NewSet(att...))

	start := time.Now()
	ctx, _span := otel.Tracer(_d._instance).Start(ctx, "References.Publish")
	defer _span.End()

	published, notfound, unpublished, err = _d.References.Publish(ctx, spaceId, envId, references, recursive, force)

	_d.requestMetrics.DurationMilliseconds.Record(ctx, time.Since(start).Milliseconds(), attributes)

	var spID string
	spID = spaceId
	if spID != "" {
		att = append(att, attribute.String("spaceID", spID))
	}
	caller, _ := pkgId.NewObjectId(auth.GetPrincipal(ctx))
	if caller != nil {
		att = append(att, attribute.String("caller", caller.String()))
	}

	_d.requestMetrics.Total.Add(ctx, 1, otelmetric.WithAttributeSet(attribute.NewSet(att...)))

	if _d._spanDecorator != nil {
		_d._spanDecorator(_span, map[string]interface{}{
			"ctx":        ctx,
			"spaceId":    spaceId,
			"envId":      envId,
			"references": references,
			"recursive":  recursive,
			"force":      force}, map[string]interface{}{
			"published":   published,
			"notfound":    notfound,
			"unpublished": unpublished,
			"err":         err})
	} else if err != nil {
		_d.requestMetrics.FailedTotal.Add(ctx, 1, attributes)

		_span.RecordError(err)
		_span.SetAttributes(attribute.String("event", "error"))
		_span.SetAttributes(attribute.String("message", err.Error()))
	}

	return published, notfound, unpublished, err
}
