// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.5.1
// - protoc             v5.28.3
// source: files/files.proto

package files

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.64.0 or later.
const _ = grpc.SupportPackageIsVersion9

const (
	Files_StartUpload_FullMethodName    = "/files.Files/StartUpload"
	Files_CompleteUpload_FullMethodName = "/files.Files/CompleteUpload"
	Files_AbortUpload_FullMethodName    = "/files.Files/AbortUpload"
	Files_MoveUpload_FullMethodName     = "/files.Files/MoveUpload"
	Files_Upload_FullMethodName         = "/files.Files/Upload"
	Files_GetFile_FullMethodName        = "/files.Files/GetFile"
	Files_DeleteFile_FullMethodName     = "/files.Files/DeleteFile"
)

// FilesClient is the client API for Files service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type FilesClient interface {
	// StartUpload - инициирует процедуру загрузки файла в файловое хранилище.
	// Используется клиентским приложением для начала загрузки файла
	// Требуемые параметры: объект `MultipartUpload` с вложенным объектом `File`, в котором
	// обязательные поля  Name и Size.
	// Возвращает объект с заполненными полями ID, PartSize, PartURLs, MimeType, Size, UploadID.
	StartUpload(ctx context.Context, in *StartUploadRequest, opts ...grpc.CallOption) (*StartUploadResponse, error)
	// CompleteUpload - завершает процедуру загрузку файла
	// Предполагается, что в объекте, полученном из `StartUpload`, клиент должен заполнить поле
	// Parts (идентификаторами загруженных блоков (S3 ETAGs)) и передать его в `CompleteUpload`
	CompleteUpload(ctx context.Context, in *CompleteUploadRequest, opts ...grpc.CallOption) (*CompleteUploadResponse, error)
	// AbortUpload - прерывает процедуру загрузки файла, все загруженные части файла удаляются их хранилища
	AbortUpload(ctx context.Context, in *AbortUploadRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// MoveUpload - перемещает загруженный файл из временного расположения в постоянное месторасположения.
	// После перемещение загрузки хранилище выдает новый идентификатор постоянного файла
	MoveUpload(ctx context.Context, in *MoveUploadRequest, opts ...grpc.CallOption) (*MoveUploadResponse, error)
	// Upload - инициация загрузки файла в хранилище. Возвращает объект, содержащий подписанный URL.
	// Завершение загрузки файла осуществляется выполнением POST-запроса
	Upload(ctx context.Context, in *UploadRequest, opts ...grpc.CallOption) (*UploadResponse, error)
	// GetFile - получить информацию о файле (ссылку) по ID
	GetFile(ctx context.Context, in *GetFileRequest, opts ...grpc.CallOption) (*GetFileResponse, error)
	// DeleteFile - удаляет файл. Если происходит удаление оригинала,
	// удаляются и все связанные структуры
	// Возможны следующие ситуации:
	//   - Удаление оригинального файла. Удаляется файл и все связанные с ним файлы.
	//   - Удаление связанного файла. Для удаления конкретного файла передается 'ID', 'Type' и 'Name'
	//   - Удаления связанных файлов конкретного типа (например, все 'thumbnails'). Передается 'ID' и 'Type'
	DeleteFile(ctx context.Context, in *DeleteFileRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
}

type filesClient struct {
	cc grpc.ClientConnInterface
}

func NewFilesClient(cc grpc.ClientConnInterface) FilesClient {
	return &filesClient{cc}
}

func (c *filesClient) StartUpload(ctx context.Context, in *StartUploadRequest, opts ...grpc.CallOption) (*StartUploadResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(StartUploadResponse)
	err := c.cc.Invoke(ctx, Files_StartUpload_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *filesClient) CompleteUpload(ctx context.Context, in *CompleteUploadRequest, opts ...grpc.CallOption) (*CompleteUploadResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(CompleteUploadResponse)
	err := c.cc.Invoke(ctx, Files_CompleteUpload_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *filesClient) AbortUpload(ctx context.Context, in *AbortUploadRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, Files_AbortUpload_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *filesClient) MoveUpload(ctx context.Context, in *MoveUploadRequest, opts ...grpc.CallOption) (*MoveUploadResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(MoveUploadResponse)
	err := c.cc.Invoke(ctx, Files_MoveUpload_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *filesClient) Upload(ctx context.Context, in *UploadRequest, opts ...grpc.CallOption) (*UploadResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(UploadResponse)
	err := c.cc.Invoke(ctx, Files_Upload_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *filesClient) GetFile(ctx context.Context, in *GetFileRequest, opts ...grpc.CallOption) (*GetFileResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(GetFileResponse)
	err := c.cc.Invoke(ctx, Files_GetFile_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *filesClient) DeleteFile(ctx context.Context, in *DeleteFileRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, Files_DeleteFile_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// FilesServer is the server API for Files service.
// All implementations must embed UnimplementedFilesServer
// for forward compatibility.
type FilesServer interface {
	// StartUpload - инициирует процедуру загрузки файла в файловое хранилище.
	// Используется клиентским приложением для начала загрузки файла
	// Требуемые параметры: объект `MultipartUpload` с вложенным объектом `File`, в котором
	// обязательные поля  Name и Size.
	// Возвращает объект с заполненными полями ID, PartSize, PartURLs, MimeType, Size, UploadID.
	StartUpload(context.Context, *StartUploadRequest) (*StartUploadResponse, error)
	// CompleteUpload - завершает процедуру загрузку файла
	// Предполагается, что в объекте, полученном из `StartUpload`, клиент должен заполнить поле
	// Parts (идентификаторами загруженных блоков (S3 ETAGs)) и передать его в `CompleteUpload`
	CompleteUpload(context.Context, *CompleteUploadRequest) (*CompleteUploadResponse, error)
	// AbortUpload - прерывает процедуру загрузки файла, все загруженные части файла удаляются их хранилища
	AbortUpload(context.Context, *AbortUploadRequest) (*emptypb.Empty, error)
	// MoveUpload - перемещает загруженный файл из временного расположения в постоянное месторасположения.
	// После перемещение загрузки хранилище выдает новый идентификатор постоянного файла
	MoveUpload(context.Context, *MoveUploadRequest) (*MoveUploadResponse, error)
	// Upload - инициация загрузки файла в хранилище. Возвращает объект, содержащий подписанный URL.
	// Завершение загрузки файла осуществляется выполнением POST-запроса
	Upload(context.Context, *UploadRequest) (*UploadResponse, error)
	// GetFile - получить информацию о файле (ссылку) по ID
	GetFile(context.Context, *GetFileRequest) (*GetFileResponse, error)
	// DeleteFile - удаляет файл. Если происходит удаление оригинала,
	// удаляются и все связанные структуры
	// Возможны следующие ситуации:
	//   - Удаление оригинального файла. Удаляется файл и все связанные с ним файлы.
	//   - Удаление связанного файла. Для удаления конкретного файла передается 'ID', 'Type' и 'Name'
	//   - Удаления связанных файлов конкретного типа (например, все 'thumbnails'). Передается 'ID' и 'Type'
	DeleteFile(context.Context, *DeleteFileRequest) (*emptypb.Empty, error)
	mustEmbedUnimplementedFilesServer()
}

// UnimplementedFilesServer must be embedded to have
// forward compatible implementations.
//
// NOTE: this should be embedded by value instead of pointer to avoid a nil
// pointer dereference when methods are called.
type UnimplementedFilesServer struct{}

func (UnimplementedFilesServer) StartUpload(context.Context, *StartUploadRequest) (*StartUploadResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method StartUpload not implemented")
}
func (UnimplementedFilesServer) CompleteUpload(context.Context, *CompleteUploadRequest) (*CompleteUploadResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CompleteUpload not implemented")
}
func (UnimplementedFilesServer) AbortUpload(context.Context, *AbortUploadRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AbortUpload not implemented")
}
func (UnimplementedFilesServer) MoveUpload(context.Context, *MoveUploadRequest) (*MoveUploadResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method MoveUpload not implemented")
}
func (UnimplementedFilesServer) Upload(context.Context, *UploadRequest) (*UploadResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Upload not implemented")
}
func (UnimplementedFilesServer) GetFile(context.Context, *GetFileRequest) (*GetFileResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetFile not implemented")
}
func (UnimplementedFilesServer) DeleteFile(context.Context, *DeleteFileRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteFile not implemented")
}
func (UnimplementedFilesServer) mustEmbedUnimplementedFilesServer() {}
func (UnimplementedFilesServer) testEmbeddedByValue()               {}

// UnsafeFilesServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to FilesServer will
// result in compilation errors.
type UnsafeFilesServer interface {
	mustEmbedUnimplementedFilesServer()
}

func RegisterFilesServer(s grpc.ServiceRegistrar, srv FilesServer) {
	// If the following call pancis, it indicates UnimplementedFilesServer was
	// embedded by pointer and is nil.  This will cause panics if an
	// unimplemented method is ever invoked, so we test this at initialization
	// time to prevent it from happening at runtime later due to I/O.
	if t, ok := srv.(interface{ testEmbeddedByValue() }); ok {
		t.testEmbeddedByValue()
	}
	s.RegisterService(&Files_ServiceDesc, srv)
}

func _Files_StartUpload_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(StartUploadRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(FilesServer).StartUpload(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Files_StartUpload_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(FilesServer).StartUpload(ctx, req.(*StartUploadRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Files_CompleteUpload_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CompleteUploadRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(FilesServer).CompleteUpload(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Files_CompleteUpload_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(FilesServer).CompleteUpload(ctx, req.(*CompleteUploadRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Files_AbortUpload_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AbortUploadRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(FilesServer).AbortUpload(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Files_AbortUpload_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(FilesServer).AbortUpload(ctx, req.(*AbortUploadRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Files_MoveUpload_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(MoveUploadRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(FilesServer).MoveUpload(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Files_MoveUpload_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(FilesServer).MoveUpload(ctx, req.(*MoveUploadRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Files_Upload_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UploadRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(FilesServer).Upload(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Files_Upload_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(FilesServer).Upload(ctx, req.(*UploadRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Files_GetFile_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetFileRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(FilesServer).GetFile(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Files_GetFile_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(FilesServer).GetFile(ctx, req.(*GetFileRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Files_DeleteFile_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteFileRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(FilesServer).DeleteFile(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Files_DeleteFile_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(FilesServer).DeleteFile(ctx, req.(*DeleteFileRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Files_ServiceDesc is the grpc.ServiceDesc for Files service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Files_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "files.Files",
	HandlerType: (*FilesServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "StartUpload",
			Handler:    _Files_StartUpload_Handler,
		},
		{
			MethodName: "CompleteUpload",
			Handler:    _Files_CompleteUpload_Handler,
		},
		{
			MethodName: "AbortUpload",
			Handler:    _Files_AbortUpload_Handler,
		},
		{
			MethodName: "MoveUpload",
			Handler:    _Files_MoveUpload_Handler,
		},
		{
			MethodName: "Upload",
			Handler:    _Files_Upload_Handler,
		},
		{
			MethodName: "GetFile",
			Handler:    _Files_GetFile_Handler,
		},
		{
			MethodName: "DeleteFile",
			Handler:    _Files_DeleteFile_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "files/files.proto",
}
